/**
 * Machikomake
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * mckm.h(header file)
 */

#include <PalmOS.h>
#include "mckm_rsc.h"

#define TRUE 1
#define FALSE 0
#define randomize() SysRandom(TimGetTicks())
#define randN(N) ((((long) SysRandom(0)) * N) / ((long) sysRandomMax + 1))

/* trifunc */
extern int sintbl[], costbl[];
int getDeg(int, int);

/* displaymanager */
extern BitmapPtr objectBitmapPtr[bitmapTypeCount];

void createScreenBuffer();
void clearDisplay();
void startDrawOffscreen();
void endDrawOffscreen();
void flipDisplay();
void loadBitmaps();
void unloadBitmaps();
void clearRectangle(int, int, int, int);
void drawThickLine(int, int, int, int);

/* vector */
#define RSL 4

typedef struct {
  int x, y;
} Vector;

long vctInnerProduct(Vector*, Vector*);
Vector vctGetElement(Vector*, Vector*);
void Add(Vector*, Vector*);
void vctSub(Vector*, Vector*);
void vctMul(Vector*, int);
void vctDiv(Vector*, int);

/* gamemanager */
typedef struct {
  Vector pos;
  Vector vel;
  int d, pd;
  int strLgt;
  Boolean tns;
} Ball;

typedef struct {
  int x, y;
  int cnt;
} MessageBoard;

#define TITLE 0
#define GAME_IN_PROGRESS 1
#define GAME_END 2

typedef struct {
  int status;
  int score;
  int time;
  int endCnt;
} GameStatus;

void startGame();
void initGame();
void startTitle();
void initTitle();
void initFirst();
void handleGameStatus();

// event loop interval
#define INTERVAL 5

