/**
 * Machikomake
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * vector.c(vector functions)
 */

#include "mckm.h"

long vctInnerProduct(Vector *v1, Vector *v2) {
  return (long)v1->x*v2->x + (long)v1->y*v2->y;
}

Vector vctGetElement(Vector *v1, Vector *v2) {
  Vector ans;
  long ll = (long)v2->x*v2->x + (long)v2->y*v2->y;
  if ( ll != 0 ) {
    long mag = vctInnerProduct(v1, v2);
    ans.x = mag*v2->x/ll;
    ans.y = mag*v2->y/ll;
  } else {
    ans.x = ans.y = 0; 
  }
  return ans;
}

void vctAdd(Vector *v1, Vector *v2) {
  v1->x += v2->x;
  v1->y += v2->y;
}

void vctSub(Vector *v1, Vector *v2) {
  v1->x -= v2->x;
  v1->y -= v2->y;
}

void vctMul(Vector *v1, int a) {	
  v1->x *= a;
  v1->y *= a;
}

void vctDiv(Vector *v1, int a) {	
  v1->x /= a;
  v1->y /= a;
}
